<template>
  <div>
    <h2>測定日</h2>
    <v-container>
      <v-row dense>
        <v-col cols="5">
          <inline-date-picker v-model="measuringDate" />
        </v-col>
        <v-col cols="5">
          <v-text-field label="タイトル" v-model="title" dense />
        </v-col>
        <v-col cols="2">
          <v-btn small @click="dataSave">保存</v-btn>
        </v-col>
      </v-row>
      <v-row dense>
        <v-col cols="10">
          <v-select
            label="データ読み込み"
            v-model="selectEdit"
            :items="saveDataList"
            clearable
            dense
            @change="dataLoad"
          />
        </v-col>
        <v-col cols="2">
          <v-btn small @click="dataDelete">削除</v-btn>
        </v-col>
      </v-row>
    </v-container>
    <h2>計算結果</h2>
    タイヤ直径 [{{ resultData["TireDiameter"] }} mm]
    <h3>車高（ホイール中心からフェンダーまで）</h3>
    左前 [{{ resultData["HeightFrontLeft"] }} mm]
    右前 [{{ resultData["HeightFrontRight"] }} mm]
    左後 [{{ resultData["HeightRearLeft"] }} mm]
    右後 [{{ resultData["HeightRearRight"] }} mm]
    <h3>トーイン</h3>
    <div>
      【フロント】
      左 [{{ resultData["ToeFrontLeft"] }} °]
      右 [{{ resultData["ToeFrontRight"] }} °]
      トータル [{{ resultData["ToeFront"] }} °]
      簡易トーイン [{{ resultData["EasyToeFront"] }} °]
      [{{ resultData["EasyToeFrontMm"] }} mm]
    </div>
    <div>
      【リア】 左 [{{ resultData["ToeRearLeft"] }} °]
      右 [{{ resultData["ToeRearRight"] }} °]
      トータル [{{ resultData["ToeRear"] }} °]
      簡易トーイン [{{ resultData["EasyToeRear"] }} °]
      [{{ resultData["EasyToeRearMm"] }} mm]
    </div>
    <h3>キャンバー</h3>
    <div>
      【フロント】
      左 [{{ resultData["CamberFrontLeft"] }} °]
      右 [{{ resultData["CamberFrontRight"] }} °]
      【リア】
      左 [{{ resultData["CamberRearLeft"] }} °]
      右 [{{ resultData["CamberRearRight"] }} °]
    </div>
    <h3>キャスター</h3>
    <div>
      左 [{{ resultData["CasterLeft"] }} °]
      右 [{{ resultData["CasterRight"] }} °]
    </div>

    <h2>逆向き</h2>
    <h3>車高（ホイール中心からフェンダーまで）</h3>
    左前 [{{ resultData["RvsHeightFrontLeft"] }} mm]
    右前 [{{ resultData["RvsHeightFrontRight"] }} mm]
    左後 [{{ resultData["RvsHeightRearLeft"] }} mm]
    右後 [{{ resultData["RvsHeightRearRight"] }} mm]
    <h3>キャンバー</h3>
    <div>
      【フロント】
      左 [{{ resultData["RvsCamberFrontLeft"] }} °]
      右 [{{ resultData["RvsCamberFrontRight"] }} °]
      【リア】
      左 [{{ resultData["RvsCamberRearLeft"] }} °]
      右 [{{ resultData["RvsCamberRearRight"] }} °]
    </div>

    <h2>平均</h2>
    <h3>車高（ホイール中心からフェンダーまで）</h3>
    左前 [{{ resultData["AveHeightFrontLeft"] }} mm]
    右前 [{{ resultData["AveHeightFrontRight"] }} mm]
    左後 [{{ resultData["AveHeightRearLeft"] }} mm]
    右後 [{{ resultData["AveHeightRearRight"] }} mm]
    <h3>キャンバー</h3>
    <div>
      【フロント】
      左 [{{ resultData["AveCamberFrontLeft"] }} °]
      右 [{{ resultData["AveCamberFrontRight"] }} °]
      【リア】
      左 [{{ resultData["AveCamberRearLeft"] }} °]
      右 [{{ resultData["AveCamberRearRight"] }} °]
    </div>
    <form name="measurement">
      <v-container>
        <h2>メモ</h2>
        <v-textarea name="memo" v-model="formData['memo']" cols="50" rows="5" />
        <h2>測定</h2>
        <v-row dense>
          <v-col cols="6">
            <v-text-field
              dense
              prefix="前後距離"
              type="number"
              name="FRdist"
              v-model.number="formData['FRdist']"
              @change="refreshToe"
              placeholder="402"
              suffix="mm"
            />
          </v-col>
          <v-col cols="6">
            <v-text-field
              dense
              prefix="上下距離"
              type="number"
              name="ULdist"
              v-model.number="formData['ULdist']"
              @change="
                refreshCamber();
                refreshCaster();
              "
              placeholder="402"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <v-row dense>
          <v-col cols="3"> 1回転切れ角 </v-col>
          <v-col cols="3">
            <v-text-field
              dense
              prefix="内"
              type="number"
              step="0.1"
              name="TurnDegIn"
              v-model.number="formData['TurnDegIn']"
              @change="refreshCaster"
              placeholder="27"
              suffix="°"
            />
          </v-col>
          <v-col cols="3">
            <v-text-field
              dense
              prefix="外"
              type="number"
              step="0.1"
              name="TurnDegOut"
              v-model.number="formData['TurnDegOut']"
              @change="refreshCaster"
              placeholder="24"
              suffix="°"
            />
          </v-col>
          <v-col cols="3">
            <v-text-field
              dense
              prefix="SAI"
              type="number"
              step="0.1"
              name="SAI"
              v-model.number="formData['SAI']"
              @change="refreshCaster"
              placeholder="11.7"
              suffix="°"
            />
          </v-col>
        </v-row>
        <v-row dense>
          <v-col cols="3"> タイヤサイズ </v-col>
          <v-col cols="2">
            <v-text-field
              dense
              type="number"
              step="10"
              name="TireW"
              v-model.number="formData['TireW']"
              @change="refreshToe"
              placeholder="195"
            />
          </v-col>
          <v-col cols="2">
            <v-text-field
              prefix="/"
              dense
              type="number"
              step="5"
              name="TireH"
              v-model.number="formData['TireH']"
              @change="refreshToe"
              placeholder="50"
            />
          </v-col>
          <v-col cols="2">
            <v-text-field
              prefix="R"
              dense
              type="number"
              name="WheelR"
              v-model.number="formData['WheelR']"
              @change="refreshToe"
              placeholder="15"
            />
          </v-col>
        </v-row>
        <v-row dense>
          <v-col cols="3"> トー測定位置高さ </v-col>
          <v-col cols="3">
            <v-text-field
              dense
              type="number"
              name="MeasureH"
              v-model.number="formData['MeasureH']"
              @change="refreshToe"
              placeholder="96"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>車高（リム下端からフェンダーまで）</h3>
        <v-row dense>
          <v-col cols="8" sm="12">
            <v-text-field
              dense
              prefix="ホイールリム径"
              type="number"
              step="0.5"
              name="rimD"
              v-model.number="formData['rimD']"
              @change="refreshHeightAll"
              placeholder="414"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="右前"
              type="number"
              step="0.5"
              name="FrontRightH"
              v-model.number="formData['FrontRightH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="右後"
              type="number"
              step="0.5"
              name="RearRightH"
              v-model.number="formData['RearRightH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="左後"
              type="number"
              step="0.5"
              name="RearLeftH"
              v-model.number="formData['RearLeftH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="左前"
              type="number"
              step="0.5"
              name="FrontLeftH"
              v-model.number="formData['FrontLeftH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>キャンバー</h3>
        <v-row dense>
          <v-col cols="4" sm="2"> フロント 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontRightU"
              v-model.number="formData['FrontRightU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontRightL"
              v-model.number="formData['FrontRightL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RearRightU"
              v-model.number="formData['RearRightU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RearRightL"
              v-model.number="formData['RearRightL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RearLeftU"
              v-model.number="formData['RearLeftU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RearLeftL"
              v-model.number="formData['RearLeftL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontLeftU"
              v-model.number="formData['FrontLeftU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontLeftL"
              v-model.number="formData['FrontLeftL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>キャスター</h3>
        <v-row dense>
          <v-col cols="4" sm="2"> フロント 右　 内1回転 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontRightU1TIn"
              v-model.number="formData['FrontRightU1TIn']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontRightL1TIn"
              v-model.number="formData['FrontRightL1TIn']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 左　 外1回転 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontLeftU1TOut"
              v-model.number="formData['FrontLeftU1TOut']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontLeftL1TOut"
              v-model.number="formData['FrontLeftL1TOut']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 右　 外1回転 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontRightU1TOut"
              v-model.number="formData['FrontRightU1TOut']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontRightL1TOut"
              v-model.number="formData['FrontRightL1TOut']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 左　 内1回転 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="FrontLeftU1TIn"
              v-model.number="formData['FrontLeftU1TIn']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="FrontLeftL1TIn"
              v-model.number="formData['FrontLeftL1TIn']"
              @change="refreshCaster"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>簡易トー</h3>
        <v-row dense>
          <v-col cols="8" sm="6">
            <v-text-field
              dense
              prefix="フロントトーイン"
              type="number"
              step="0.5"
              name="FrontToeIn"
              v-model.number="formData['FrontToeIn']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="7" sm="6">
            <v-text-field
              dense
              prefix="リアトーイン"
              type="number"
              step="0.5"
              name="RearToeIn"
              v-model.number="formData['RearToeIn']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>トー</h3>
        <v-row dense>
          <v-col cols="4" sm="2"> フロント 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="前"
              type="number"
              step="0.1"
              name="FrontRightF"
              v-model.number="formData['FrontRightF']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="後"
              type="number"
              step="0.1"
              name="FrontRightR"
              v-model.number="formData['FrontRightR']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="前"
              type="number"
              step="0.1"
              name="RearRightF"
              v-model.number="formData['RearRightF']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="後"
              type="number"
              step="0.1"
              name="RearRightR"
              v-model.number="formData['RearRightR']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="前"
              type="number"
              step="0.1"
              name="RearLeftF"
              v-model.number="formData['RearLeftF']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="後"
              type="number"
              step="0.1"
              name="RearLeftR"
              v-model.number="formData['RearLeftR']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="前"
              type="number"
              step="0.1"
              name="FrontLeftF"
              v-model.number="formData['FrontLeftF']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="後"
              type="number"
              step="0.1"
              name="FrontLeftR"
              v-model.number="formData['FrontLeftR']"
              @change="refreshToe"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h2>逆向き</h2>
        <h3>車高（リム下端からフェンダーまで）</h3>
        <v-row dense>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="右前"
              type="number"
              step="0.5"
              name="RvsFrontRightH"
              v-model.number="formData['RvsFrontRightH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="右後"
              type="number"
              step="0.5"
              name="RvsRearRightH"
              v-model.number="formData['RvsRearRightH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="左後"
              type="number"
              step="0.5"
              name="RvsRearLeftH"
              v-model.number="formData['RvsRearLeftH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="5" sm="3">
            <v-text-field
              dense
              prefix="左前"
              type="number"
              step="0.5"
              name="RvsFrontLeftH"
              v-model.number="formData['RvsFrontLeftH']"
              @change="refreshHeightAll"
              suffix="mm"
            />
          </v-col>
        </v-row>
        <h3>キャンバー</h3>
        <v-row dense>
          <v-col cols="4" sm="2"> フロント 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RvsFrontRightU"
              v-model.number="formData['RvsFrontRightU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RvsFrontRightL"
              v-model.number="formData['RvsFrontRightL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 右 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RvsRearRightU"
              v-model.number="formData['RvsRearRightU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RvsRearRightL"
              v-model.number="formData['RvsRearRightL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> リア 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RvsRearLeftU"
              v-model.number="formData['RvsRearLeftU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RvsRearLeftL"
              v-model.number="formData['RvsRearLeftL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2"> フロント 左 </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="上"
              type="number"
              step="0.1"
              name="RvsFrontLeftU"
              v-model.number="formData['RvsFrontLeftU']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
          <v-col cols="4" sm="2">
            <v-text-field
              dense
              prefix="下"
              type="number"
              step="0.1"
              name="RvsFrontLeftL"
              v-model.number="formData['RvsFrontLeftL']"
              @change="refreshCamberAll"
              suffix="mm"
            />
          </v-col>
        </v-row>
      </v-container>
    </form>
    <h1>基準値</h1>
    <h2>フロント</h2>
    <table name="front" border="1">
      <tr>
        <th colspan="2">項目</th>
        <th>仕様</th>
      </tr>
      <tr>
        <th rowspan="2">トータル・トーイン</th>
        <th>(mm)</th>
        <td>3±2</td>
      </tr>
      <tr>
        <th>度</th>
        <td>0°17′±11′</td>
      </tr>
      <tr>
        <th rowspan="2">切れ角</th>
        <th>内側</th>
        <td>38°±3°</td>
      </tr>
      <tr>
        <th>外側</th>
        <td>33°±3°</td>
      </tr>
      <tr>
        <th rowspan="5">キャンバ角</th>
        <th>326～335</th>
        <td>-0°36′±45′</td>
      </tr>
      <tr>
        <th>336～345</th>
        <td>-0°16′±45′</td>
      </tr>
      <tr>
        <th>346～355</th>
        <td>0°02′±45′</td>
      </tr>
      <tr>
        <th>356～365</th>
        <td>0°19′±45′</td>
      </tr>
      <tr>
        <th>366～375</th>
        <td>0°34′±45′</td>
      </tr>
      <tr>
        <th rowspan="5">キャスタ角</th>
        <th>326～335</th>
        <td>6°09′±45′</td>
      </tr>
      <tr>
        <th>336～345</th>
        <td>5°55′±45′</td>
      </tr>
      <tr>
        <th>346～355</th>
        <td>5°40′±45′</td>
      </tr>
      <tr>
        <th>356～365</th>
        <td>5°26′±45′</td>
      </tr>
      <tr>
        <th>366～375</th>
        <td>5°12′±45′</td>
      </tr>
    </table>
    <h2>リア</h2>
    <table name="rear" border="1">
      <tr>
        <th colspan="2">項目</th>
        <th>仕様</th>
      </tr>
      <tr>
        <th rowspan="2">トータル・トーイン</th>
        <th>(mm)</th>
        <td>3±2</td>
      </tr>
      <tr>
        <th>度</th>
        <td>0°17′±11′</td>
      </tr>
      <tr>
        <th rowspan="5">キャンバ角</th>
        <th>351～360</th>
        <td>-1°06′±45′</td>
      </tr>
      <tr>
        <th>361～370</th>
        <td>-0°53′±45′</td>
      </tr>
      <tr>
        <th>371～380</th>
        <td>-0°42′±45′</td>
      </tr>
      <tr>
        <th>381～390</th>
        <td>-0°34′±45′</td>
      </tr>
      <tr>
        <th>391～400</th>
        <td>-0°29′±45′</td>
      </tr>
    </table>
  </div>
</template>

<script>
import InlineDatePicker from "~/components/InlineDatePicker.vue";
export default {
  components: { InlineDatePicker },
  data: () => ({
    alignData: [],
    selectEdit: null,
    measuringDate: null,
    title: "",
    formData: {},
    resultData: {},
  }),
  computed: {
    saveDataList: function () {
      let sdList = [];
      this.alignData.forEach(function (item) {
        sdList.push(item["measuringDate"] + ":" + item["title"]);
      });
      sdList.sort().reverse();
      return sdList;
    },
  },
  mounted: function () {
    if (localStorage.getItem("alignData")) {
      try {
        this.alignData = JSON.parse(localStorage.getItem("alignData"));
      } catch (e) {
        localStorage.removeItem("alignData");
      }
    }
    this.refreshAll();
  },
  methods: {
    //再計算
    refreshAll() {
      this.refreshHeightAll();
      this.refreshToe();
      this.refreshCamberAll();
      this.refreshCaster();
    },

    //車高更新
    refreshHeightAll() {
      this.refreshHeight();
      this.refreshHeightRvs();
      this.refreshHeightAve();
    },
    refreshHeight() {
      this.resultData["HeightFrontLeft"] =
        this.formData["FrontLeftH"] - this.formData["rimD"] / 2;
      this.resultData["HeightFrontRight"] =
        this.formData["FrontRightH"] - this.formData["rimD"] / 2;
      this.resultData["HeightRearLeft"] =
        this.formData["RearLeftH"] - this.formData["rimD"] / 2;
      this.resultData["HeightRearRight"] =
        this.formData["RearRightH"] - this.formData["rimD"] / 2;
    },
    refreshHeightRvs() {
      this.resultData["RvsHeightFrontLeft"] =
        this.formData["RvsFrontLeftH"] - this.formData["rimD"] / 2;
      this.resultData["RvsHeightFrontRight"] =
        this.formData["RvsFrontRightH"] - this.formData["rimD"] / 2;
      this.resultData["RvsHeightRearLeft"] =
        this.formData["RvsRearLeftH"] - this.formData["rimD"] / 2;
      this.resultData["RvsHeightRearRight"] =
        this.formData["RvsRearRightH"] - this.formData["rimD"] / 2;
    },
    refreshHeightAve() {
      this.resultData["AveHeightFrontLeft"] = this.calcRound(
        (+this.resultData["HeightFrontLeft"] +
          +this.resultData["RvsHeightFrontLeft"]) /
          2,
        2
      );
      this.resultData["AveHeightFrontRight"] = this.calcRound(
        (+this.resultData["HeightFrontRight"] +
          +this.resultData["RvsHeightFrontRight"]) /
          2,
        2
      );
      this.resultData["AveHeightRearLeft"] = this.calcRound(
        (+this.resultData["HeightRearLeft"] +
          +this.resultData["RvsHeightRearLeft"]) /
          2,
        2
      );
      this.resultData["AveHeightRearRight"] = this.calcRound(
        (+this.resultData["HeightRearRight"] +
          +this.resultData["RvsHeightRearRight"]) /
          2,
        2
      );
    },

    //トー更新
    refreshToe() {
      //タイヤ直径
      var tireD = this.calcTireR(
        this.formData["TireW"],
        this.formData["TireH"],
        this.formData["WheelR"]
      );
      this.resultData["TireDiameter"] = tireD;

      //フロント
      this.resultData["ToeFrontLeft"] = this.calcDegree(
        this.formData["FrontLeftF"],
        this.formData["FrontLeftR"],
        this.formData["FRdist"]
      );
      this.resultData["ToeFrontRight"] = this.calcDegree(
        this.formData["FrontRightF"],
        this.formData["FrontRightR"],
        this.formData["FRdist"]
      );
      this.resultData["ToeFront"] =
        this.calcDegree(
          this.formData["FrontLeftF"],
          this.formData["FrontLeftR"],
          this.formData["FRdist"]
        ) +
        this.calcDegree(
          this.formData["FrontRightF"],
          this.formData["FrontRightR"],
          this.formData["FRdist"]
        );
      this.resultData["EasyToeFront"] = this.calcEasyToe(
        tireD,
        this.formData["MeasureH"],
        this.formData["FrontToeIn"]
      );
      this.resultData["EasyToeFrontMm"] = this.calcEasyToeMm(
        tireD,
        this.formData["MeasureH"],
        this.formData["FrontToeIn"]
      );

      //リア
      this.resultData["ToeRearLeft"] = this.calcDegree(
        this.formData["RearLeftF"],
        this.formData["RearLeftR"],
        this.formData["FRdist"]
      );
      this.resultData["ToeRearRight"] = this.calcDegree(
        this.formData["RearRightF"],
        this.formData["RearRightR"],
        this.formData["FRdist"]
      );
      this.resultData["ToeRear"] =
        this.calcDegree(
          this.formData["RearLeftF"],
          this.formData["RearLeftR"],
          this.formData["FRdist"]
        ) +
        this.calcDegree(
          this.formData["RearRightF"],
          this.formData["RearRightR"],
          this.formData["FRdist"]
        );
      this.resultData["EasyToeRear"] = this.calcEasyToe(
        tireD,
        this.formData["MeasureH"],
        this.formData["RearToeIn"]
      );
      this.resultData["EasyToeRearMm"] = this.calcEasyToeMm(
        tireD,
        this.formData["MeasureH"],
        this.formData["RearToeIn"]
      );
    },

    //キャンバー更新
    refreshCamberAll() {
      this.refreshCamber();
      this.refreshCamberRvs();
      this.refreshCamberAve();
    },
    refreshCamber() {
      //フロント
      this.resultData["CamberFrontLeft"] = this.calcDegree(
        this.formData["FrontLeftU"],
        this.formData["FrontLeftL"],
        this.formData["ULdist"]
      );
      this.resultData["CamberFrontRight"] = this.calcDegree(
        this.formData["FrontRightU"],
        this.formData["FrontRightL"],
        this.formData["ULdist"]
      );
      //リア
      this.resultData["CamberRearLeft"] = this.calcDegree(
        this.formData["RearLeftU"],
        this.formData["RearLeftL"],
        this.formData["ULdist"]
      );
      this.resultData["CamberRearRight"] = this.calcDegree(
        this.formData["RearRightU"],
        this.formData["RearRightL"],
        this.formData["ULdist"]
      );
    },
    refreshCamberRvs() {
      //フロント
      this.resultData["RvsCamberFrontLeft"] = this.calcDegree(
        this.formData["RvsFrontLeftU"],
        this.formData["RvsFrontLeftL"],
        this.formData["ULdist"]
      );
      this.resultData["RvsCamberFrontRight"] = this.calcDegree(
        this.formData["RvsFrontRightU"],
        this.formData["RvsFrontRightL"],
        this.formData["ULdist"]
      );
      //リア
      this.resultData["RvsCamberRearLeft"] = this.calcDegree(
        this.formData["RvsRearLeftU"],
        this.formData["RvsRearLeftL"],
        this.formData["ULdist"]
      );
      this.resultData["RvsCamberRearRight"] = this.calcDegree(
        this.formData["RvsRearRightU"],
        this.formData["RvsRearRightL"],
        this.formData["ULdist"]
      );
    },
    refreshCamberAve() {
      //フロント
      this.resultData["AveCamberFrontLeft"] = this.calcRound(
        (+this.resultData["CamberFrontLeft"] +
          +this.resultData["RvsCamberFrontLeft"]) /
          2,
        2
      );
      this.resultData["AveCamberFrontRight"] = this.calcRound(
        (+this.resultData["CamberFrontRight"] +
          +this.resultData["RvsCamberFrontRight"]) /
          2,
        2
      );
      //リア
      this.resultData["AveCamberRearLeft"] = this.calcRound(
        (+this.resultData["CamberRearLeft"] +
          +this.resultData["RvsCamberRearLeft"]) /
          2,
        2
      );
      this.resultData["AveCamberRearRight"] = this.calcRound(
        (+this.resultData["CamberRearRight"] +
          +this.resultData["RvsCamberRearRight"]) /
          2,
        2
      );
    },

    //キャスター更新
    refreshCaster() {
      this.resultData["CasterLeft"] = this.calcCaster(
        Math.atan(
          (this.formData["FrontLeftU1TIn"] - this.formData["FrontLeftL1TIn"]) /
            this.formData["ULdist"]
        ),
        Math.atan(
          (this.formData["FrontLeftU1TOut"] -
            this.formData["FrontLeftL1TOut"]) /
            this.formData["ULdist"]
        ),
        (this.formData["TurnDegIn"] / 180) * Math.PI,
        (-this.formData["TurnDegOut"] / 180) * Math.PI,
        (this.formData["SAI"] / 180) * Math.PI
      );
      this.resultData["CasterRight"] = this.calcCaster(
        Math.atan(
          (this.formData["FrontRightU1TIn"] -
            this.formData["FrontRightL1TIn"]) /
            this.formData["ULdist"]
        ),
        Math.atan(
          (this.formData["FrontRightU1TOut"] -
            this.formData["FrontRightL1TOut"]) /
            this.formData["ULdist"]
        ),
        (this.formData["TurnDegIn"] / 180) * Math.PI,
        (-this.formData["TurnDegOut"] / 180) * Math.PI,
        (this.formData["SAI"] / 180) * Math.PI
      );
    },

    //角度計算
    //v1, v2 : 基準線からの距離
    //dist : v1, v2の測定箇所の間の距離
    calcDegree(v1, v2, dist) {
      return this.calcRound((Math.atan((v1 - v2) / dist) * 180) / Math.PI, 2);
    },

    //キャスター計算
    //D1=C0+arccos(sin(SAI)cos(T1))+SAI+arccos(sin(CASTER)sin(T1))-PI
    //D2=C0+arccos(sin(SAI)cos(T2))+SAI+arccos(sin(CASTER)sin(T2))-PI
    //D1-D2=arccos(sin(SAI)cos(T1))-arccos(sin(SAI)cos(T2))+arccos(sin(CASTER)sin(T1))-arccos(sin(CASTER)sin(T2))
    //b=cos(D1-D2+arccos(sin(SAI)cos(T2))-arccos(sin(SAI)cos(T1)))
    //a=sin(T1)/sin(T2)
    //CASTER^2=(1-b^2)/(a^2+1-2ab)*sin(T2)^2)
    //d1, d2 : 内1回転、外1回転でのキャンバー角度
    //t1, t2 : 内1回転、外1回転での切れ角
    //sai : SAI
    calcCaster(d1, d2, t1, t2, sai) {
      //var denom = Math.cos(d2) * Math.sin(t2) - Math.cos(d1) * Math.sin(t1);
      //return calcRound(Math.atan((Math.sin(d1) - Math.sin(d2)) / denom - (Math.cos(d2) * Math.cos(t2) - Math.cos(d1) * Math.cos(t1)) / denom * Math.tan(sai)) * 180 / Math.PI, 2);
      var b = Math.cos(
        d1 -
          d2 +
          Math.acos(Math.sin(sai) * Math.cos(t2)) -
          Math.acos(Math.sin(sai) * Math.cos(t1))
      );
      var a = Math.sin(t1) / Math.sin(t2);
      return this.calcRound(
        (Math.sqrt(
          (1 - b * b) / ((a * a + 1 - 2 * a * b) * Math.sin(t2) * Math.sin(t2))
        ) *
          180) /
          Math.PI,
        2
      );
    },

    //タイヤ直径(mm)計算
    //tireW : タイヤ幅
    //tireH : タイヤ扁平率
    //wheelR : ホイール直径（インチ）
    calcTireR(tireW, tireH, wheelR) {
      return ((tireW * tireH) / 100) * 2 + wheelR * 25.4;
    },

    //簡易トーイン角度計算
    //tireD : タイヤ直径(mm)
    //measureH : トー測定位置高さ(mm)
    //toeIn : トーイン(mm)
    calcEasyToe(tireD, measureH, toeIn) {
      var r = tireD / 2;
      var measureR = Math.sqrt(r * r - (r - measureH) * (r - measureH)) * 2;
      return this.calcRound(
        (Math.asin(toeIn / 2 / measureR) * 2 * 180) / Math.PI,
        2
      );
    },

    //簡易トーイン(mm)計算
    //tireD : タイヤ直径(mm)
    //measureH : トー測定位置高さ(mm)
    //toeIn : トーイン(mm)
    calcEasyToeMm(tireD, measureH, toeIn) {
      var r = tireD / 2;
      var measureR = Math.sqrt(r * r - (r - measureH) * (r - measureH));
      return this.calcRound(toeIn * (r / measureR), 1);
    },

    //四捨五入
    //v : 数値
    //n : 桁数
    calcRound(v, n) {
      return Math.round(v * Math.pow(10, n)) / Math.pow(10, n);
    },

    //データ保存
    dataSave() {
      //データ保存
      let saveData = structuredClone({
        "measuringDate": this.measuringDate,
        "title": this.title,
        "formData": this.formData,
      });
      let index = this.alignData.findindex(function (value) {
        return (
          value["measuringDate"] == saveData["measuringDate"] &&
          value["title"] == saveData["title"]
        );
      });
      if (index >= 0) {
        this.alignData[index] = saveData;
      } else {
        this.alignData.push(saveData);
      }
      //ストレージに保存
      localStorage.setItem('alignData', JSON.stringify(this.alignData));
      //保存完了メッセージ
      alert("データを保存しました");
    },

    //保存データ読み出し
    dataLoad(selectEdit) {
      if (!selectEdit) {
        this.selectEdit = null;
        return;
      }
      //保存データ読み出し
      let loadData = null;
      this.alignData.forEach(function (item) {
        let key = item["measuringDate"] + ":" + item["title"];
        if (key == selectEdit) {
          loadData = structuredClone(item);
        }
      });
      if (loadData) {
        //フォームに設定
        this.measuringDate = loadData["measuringDate"];
        this.title = loadData["title"];
        this.formData = loadData["formData"];
        //再計算
        this.refreshAll();
      }
    },

    //保存データ削除
    dataDelete() {
      //保存データ読み出し
      let target = -1;
      const selectEdit = this.selectEdit;
      this.alignData.forEach(function (item, index) {
        let key = item["measuringDate"] + ":" + item["title"];
        if (key == selectEdit) {
          target = index;
        }
      });
      //保存データ削除
      if (target >= 0) {
        this.alignData.splice(target, 1);
        //ストレージに保存
        localStorage.setItem('alignData', JSON.stringify(this.alignData));
      }
    },
  },
};
</script>